/*
 * Project name:
     LED_Blinking (Simple 'Hello World' project)
 * Copyright:
     (c) MikroElektronika, 2011.
 * Revision History:
     20110414:
       - initial release (FJ);
 * Description:
     This is a simple 'Hello World' project. It turns on/off diodes connected to
     PORTA, PORTB, PORTC and PORTD.
 * Test configuration:
     MCU:             ATmega128
                      http://www.atmel.com/dyn/resources/prod_documents/doc2467.pdf
     Dev.Board:       UNI-DS6 - ac:LEDs
                      http://www.mikroe.com/eng/products/view/669/uni-ds6-development-system/
     Oscillator:      External Clock 10.0000 MHz
     Ext. Modules:    -
     SW:              mikroC PRO for AVR
                      http://www.mikroe.com/eng/products/view/228/mikroc-pro-for-avr/
 * NOTES:
     - Turn ON the PORT LEDs at SW12. (board specific)
*/
char counter;

void wait() {
  Delay_ms(100);
}

void main() {
  DDRA = 0xFF;     // set direction to be output
  DDRB = 0xFF;     // set direction to be output
  DDRC = 0xFF;     // set direction to be output
  DDRD = 0xFF;     // set direction to be output
  PORTA = 0x00;    // turn OFF the PORTA leds
  PORTB = 0x00;    // turn OFF the PORTB leds
  PORTC = 0x00;    // turn OFF the PORTC leds
  PORTD = 0x00;    // turn OFF the PORTD leds
  
  while (1) {
    for (counter=0; counter<8; counter++){
      PORTA |= 1 << counter;
      PORTB |= 1 << counter;
      PORTC |= 1 << counter;
      PORTD |= 1 << counter;
 
      wait();
    }
       
    counter = 0;
    while (counter<8) {
      PORTA &= ~(1 << counter);
      PORTB &= ~(1 << counter);
      PORTC &= ~(1 << counter);
      PORTD &= ~(1 << counter);
 
      wait();
      counter++;
    }
  }
}