;-----------------------------------------------------------------------------
; Project name:
;	led
; Author:
;	Goran Stojanovic, 2010.
; Description:
;	This example turns on and off two LED's. While the first LED is	turned on,
;	others off. After a delay of 500 ms, the first LED is turned off and the
;	other on. This is infinitely repeated.
; Electronic components are used: - 
; Test configuration:
;	MCU:			CY8C27643
;	Dev. Board:		EasyPSoC4 by Mikroelektronika
;	Oscillator:		Internal, 3 MHz
;   SW:				PSoC Designer Assembler
;	SW Modules:		LED
; Notes:
; 	Used ports:		port0
;	Used pins:		0 - LED_1, 1 - LED_2
;-----------------------------------------------------------------------------

include "m8c.inc"       	; part specific constants and macros
include "memory.inc"    	; Constants & macros for SMM/LMM and Compiler
include "PSoCAPI.inc"   	; PSoC API definitions for all User Modules
include "m_pause.asm"		; Assembler declarations for waiting

export _main

_main:
	call	LED_1_On				;turn On LED_1
	call	LED_2_Off				;turn Off LED_2	
l_again:							;loop begin
	pause	500						;pause 500 ms
    call	LED_1_Invert			;inverts state of LED_1
	call	LED_2_Invert			;inverts state of LED_1
	jmp		l_again					;loop forever

.terminate:
    jmp .terminate
