;-----------------------------------------------------------------------------
; Assembly main line
; Slanje podataka preko UART-a
; (SW1: RX - port0-6, TX - port0-7) (19200 baud)
;-----------------------------------------------------------------------------

include "m8c.inc"       ; part specific constants and macros
include "memory.inc"    ; Constants & macros for SMM/LMM and Compiler
include "PSoCAPI.inc"   ; PSoC API definitions for all User Modules

export _main
area bss(RAM)
	TxData: blk 1
	RxData: blk 1
	u16_1:BLK 2
	u16_2:BLK 2
	u16_3:BLK 2
	brojcif:BLK 1
	
area text (ROM,REL)

//Izracunava kolicnik dva sesnaestobitna broja.
//@2=@0 div @1
macro div_16_16_u
	mov		A,[@1+0]			;Delilac
	push	A
	mov		A,[@1+1]
	push	A
	mov		A,[@0+0]			;Deljenik
	push	A
	mov		A,[@0+1]
	push	A
	lcall	divu_16x16_16		;Deljenje
	mov		[@2+1],A			;Pamcenje LSB
	mov		[@2+0],X			;Pamcenje MSB
	add		SP,252				;pop the stack		
endm

//Izracunava ostatak celobrojnog deljenja dva sesnaestobitna broja.
//@2=@0 mod @1
macro mod_16_16_u
	mov		A,[@1+0]			;Delilac
	push	A
	mov		A,[@1+1]
	push	A
	mov		A,[@0+0]			;Deljenik
	push	A
	mov		A,[@0+1]
	push	A
	lcall	modu_16x16_16		;Deljenje
	mov		[@2+1],A			;Pamcenje LSB
	mov		[@2+0],X			;Pamcenje MSB
	add		SP,252				;pop the stack		
endm

macro proba1
	mov  A,UART_1_PARITY_NONE
	call UART_1_Start
WaitRxComplete:
	call UART_1_bReadRxStatus
	and A, UART_1_RX_COMPLETE
	jz WaitRxComplete
	call UART_1_bReadRxData
	mov [RxData],A
WaitTxEmpty:
	call UART_1_bReadTxStatus
	and A,UART_1_TX_BUFFER_EMPTY
	jz WaitTxEmpty
	mov A,[RxData]
	call UART_1_SendData	
      jmp WaitRxComplete	
endm

macro proba2
ponovo2:
	mov  A,UART_1_PARITY_NONE
	call UART_1_Start
 	call UART_1_cGetChar
 	mov [RxData],A
 	call UART_1_PutChar
	jmp ponovo2
endm

macro proba3
ponovo3:
	mov  A,UART_1_PARITY_NONE
	call UART_1_Start
 	call UART_1_cGetChar
 	mov [RxData],A
 	call UART_1_PutSHexByte
	jmp ponovo3
endm

macro proba4
	mov		A,UART_1_PARITY_NONE
	call	UART_1_Start		
	mov		A,'1'
	push	A
	mov		A,'2'
	push	A
	mov		A,'3'
	push	A
	mov		[brojcif],3
saljijos1:	
WaitTxEmpty:
	call UART_1_bReadTxStatus
	and A,UART_1_TX_BUFFER_EMPTY
	jz WaitTxEmpty
	pop		A
	call UART_1_SendData	
	dec		[brojcif]
	cmp		[brojcif],0
	jnz		saljijos1	
endm

macro proba5
	mov		A,UART_1_PARITY_NONE
	call	UART_1_Start	
	mov		A,'1'
	push	A
	mov		A,'2'
	push	A
	mov		A,'3'
	push	A
	mov		[brojcif],3
saljijos2:	
	pop		A
 	call	UART_1_PutChar
	dec		[brojcif]
	cmp		[brojcif],0
	jnz		saljijos2	
endm

//Odredjuje dekadne cifre 16-bitnog broja
macro odredi_dek_cifre 
	mov		[brojcif],0			;brojcifara=0
	mov		[u16_2+0],0
	mov		[u16_2+1],$0A		;delilac=10	
	mov		[u16_1+0],>@0
	mov		[u16_1+1],<@0	
jos:
	mod_16_16_u u16_1,u16_2,u16_3
	mov		A,[u16_3+1]
	add		A,48		;ASCII
	push	A
	inc		[brojcif]	
	div_16_16_u u16_1,u16_2,u16_3
	cmp		[u16_3+0],0
	jnz		kopi
	cmp		[u16_3+1],0
	jz		prekid
kopi:
	mov		[u16_1+0],[u16_3+0]
	mov		[u16_1+1],[u16_3+1]
	jmp		jos	
prekid:	
endm

macro proba6
	mov		A,UART_1_PARITY_NONE
	call	UART_1_Start
	odredi_dek_cifre 32765
saljijos3:	
	pop		A
 	call	UART_1_PutChar
	dec		[brojcif]
	cmp		[brojcif],0
	jnz		saljijos3	
endm

_main:
//	proba1	
//	proba2
//	proba3	
//	proba4
//	proba5	
	proba6
	

.terminate:
    jmp .terminate
